#!/usr/bin/ruby

require 'facehugger'
require 'RMagick'
require 'yaml'

gallery = {
    :urls => "http://2.bp.blogspot.com/-sRejIPLgEaY/Tqe0887jyOI/AAAAAAAAAm4/yEL9k2pxfG4/s1600/man-4+patrickhoelck-4e308eb4e5e102.jpg",
    :file => "data/group-of-people.jpg"
}

fs_image = [
    "data/joe-manganiello.jpg",
    "data/group-of-people.jpg"
]

FACE_ACCOUNT = YAML.load open File.join File.dirname(__FILE__), "../spec/config", "face.yml"

facehugger = Facehugger.new(:api_key => FACE_ACCOUNT['api_key'],
                            :api_secret => FACE_ACCOUNT['api_secret'])

gallery.each_with_index do |(key, value), i|
  img = Magick::Image.read(fs_image[i])[0]
  w = img.columns
  h = img.rows

  new_height = (w * 2.0 / 3).to_i
  photos = facehugger.faces_detect(key => value)

  photos.each do |photo|
    tag = photo.tags.first
    puts tag.inspect

    img.crop!(0, (h * tag.center['y'] / 100.0) - new_height / 2, w, new_height)
    img.resize(w, new_height).write("data/cropped-#{i}.jpg")
  end
end
