require 'yajl'

module Face
  module API
    {
        :faces_detect => 'http://api.face.com/faces/detect.json',
        :account_limits => 'http://api.face.com/account/limits.json',
    }.each do |name, url|
      define_method(name) do |*args|
        full_url = url + "?api_key=#{@api_key}&api_secret=#{@api_secret}"

        options = args[0] || {}
        file_upload = nil

        options.each do |key, value|
          case key
            when :file || 'file'
              file_upload = File.new(value, 'rb') if File.exists?(value)
            else
              full_url += "&#{key}=#{value}"
          end
        end

        begin
          if file_upload
            Yajl::Parser.parse RestClient.post full_url, :file => file_upload
          else
            Yajl::Parser.parse RestClient.get full_url
          end
        rescue => e
          Yajl::Parser.parse e.response
        end
      end
    end
  end
end