module Face
  base_class = Class.new do
    def initialize(hash)
      hash.each do |k, v|

        # create and initialize an instance variable for this key/value pair
        self.instance_variable_set("@#{k}", v)

        # create the getter that returns the instance variable
        self.class.send(:define_method, k, proc { self.instance_variable_get("@#{k}") })

        # create the setter that sets the instance variable
        self.class.send(:define_method, "#{k}=", proc { |v| self.instance_variable_set("@#{k}", v) })
      end
    end
  end

  ["Photo", "Tag"].each do |const_name|
    const_set(const_name, base_class.clone)
  end
end
