require 'face/api'
require 'face/base'
require 'json'
require 'rest_client'

class Facehugger
  include Face::API

  attr_accessor :api_key, :api_secret

  def initialize(args = {:api_key => "", :api_secret => ""})
    @api_key = args[:api_key]
    @api_secret = args[:api_secret]
  end

  def valid?
    response = account_limits
    response['status'] == 'success'
  end

  def self.photos(response = {})
    photos = []

    if response.has_key? 'photos'
      response['photos'].each do |photo|
        photos << Face::Photo.new(photo)
      end
    end

    photos
  end

  def faces_detect(args = {})
    response = super args
    return nil if response['status'] != 'success'

    photos = Facehugger.photos response
    return nil if photos.nil?

    photos.each do |photo|
      tags = []

      photo.tags.sort_by! do |t|
        t['attributes']['face']['confidence']
      end.reverse.each do |tag|
        tags << Face::Tag.new(tag)
      end

      photo.tags = tags
    end

    photos
  end
end